Index: trunk/LMDZ.GENERIC/libf/phystd/physdem1.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/physdem1.F	(revision 786)
+++ trunk/LMDZ.GENERIC/libf/phystd/physdem1.F	(revision 787)
@@ -1,8 +1,11 @@
-      subroutine physdem1(filename,lonfi,latfi,nsoil,nq,
+      subroutine physdem1(ngrid,filename,lonfi,latfi,nsoil,nq,
      .                   phystep,day_ini,
      .                   time,tsurf,tsoil,emis,q2,qsurf,
      .                   airefi,alb,ith,pzmea,pzstd,pzsig,pzgam,pzthe,
-     .                   cloudfrac,totcloudfrac,hice)
-
+     .                   cloudfrac,totcloudfrac,hice,nametrac)
+
+      use surfdat_h
+      use comsoil_h
+      USE comgeomfi_h
  
       implicit none
@@ -36,6 +39,7 @@
 #include "netcdf.inc"
 #include "dimphys.h"
-#include"advtrac.h"
 #include"callkeys.h"
+
+      INTEGER :: ngrid
 
       INTEGER nid,iq
@@ -50,7 +54,7 @@
 
       REAL phystep,time
-      REAL latfi(ngridmx), lonfi(ngridmx)
-!      REAL champhys(ngridmx)
-      REAL tsurf(ngridmx)
+      REAL latfi(ngrid), lonfi(ngrid)
+!      REAL champhys(ngrid)
+      REAL tsurf(ngrid)
       INTEGER length
       PARAMETER (length=100)
@@ -58,6 +62,10 @@
 
 !     added by BC
-      REAL hice(ngridmx),cloudfrac(ngridmx,nlayermx)
-      REAL totcloudfrac(ngridmx)
+      REAL hice(ngrid),cloudfrac(ngrid,nlayermx)
+      REAL totcloudfrac(ngrid)
+
+!     AS: name of tracers added as an argument to avoid using nqmx in commons (i.e. adv trac)
+!       nota: physdem1 is used both in physiq and newstart.
+      character*20 nametrac(nq)   ! name of the tracer
 
 
@@ -68,16 +76,13 @@
 #include "clesph0.h"
 #include "fxyprim.h"
-#include "comgeomfi.h"
-#include "surfdat.h"
-#include "comsoil.h"
 #include "planete.h"
 #include "comcstfi.h"
 
-      real tsoil(ngridmx,nsoil),emis(ngridmx)
-      real q2(ngridmx, llm+1),qsurf(ngridmx,nq)
-      real airefi(ngridmx)
-      real alb(ngridmx),ith(ngridmx,nsoil)
-      real pzmea(ngridmx),pzstd(ngridmx)
-      real pzsig(ngridmx),pzgam(ngridmx),pzthe(ngridmx)
+      real tsoil(ngrid,nsoil),emis(ngrid)
+      real q2(ngrid, llm+1),qsurf(ngrid,nq)
+      real airefi(ngrid)
+      real alb(ngrid),ith(ngrid,nsoil)
+      real pzmea(ngrid),pzstd(ngrid)
+      real pzsig(ngrid),pzgam(ngrid),pzthe(ngrid)
       integer ig
 
@@ -92,8 +97,8 @@
 
       ! copy airefi(:) to area(:)
-      CALL SCOPY(ngridmx,airefi,1,area,1)
+      CALL SCOPY(ngrid,airefi,1,area,1)
       ! note: area() is defined in comgeomfi.h
 
-      DO ig=1,ngridmx
+      DO ig=1,ngrid
          albedodat(ig)=alb(ig) ! note: albedodat() is defined in surfdat.h
          zmea(ig)=pzmea(ig) ! note: zmea() is defined in surfdat.h
@@ -127,5 +132,5 @@
       endif
 c
-      ierr = NF_DEF_DIM (nid,"physical_points",ngridmx,idim2)
+      ierr = NF_DEF_DIM (nid,"physical_points",ngrid,idim2)
       if (ierr.ne.NF_NOERR) then
         WRITE(6,*)'physdem1: Problem defining physical_points dimension'
@@ -169,5 +174,5 @@
       ENDDO
 
-      write(*,*) "physdem1: ngridmx: ",ngridmx
+      write(*,*) "physdem1: ngrid: ",ngrid
 
 ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
@@ -175,5 +180,5 @@
 ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 c Informations on the physics grid
-      tab_cntrl(1) = float(ngridmx)  ! number of nodes on physics grid
+      tab_cntrl(1) = float(ngrid)  ! number of nodes on physics grid
       tab_cntrl(2) = float(nlayermx) ! number of atmospheric layers
       tab_cntrl(3) = day_ini + int(time)         ! initial day 
@@ -618,8 +623,8 @@
 !                    qsurf02, ...)
       count=0
-      do iq=1,nqmx
+      do iq=1,nq
         txt= " "
         write(txt,'(a1,i2.2)')'q',iq
-        if (txt.ne.tnom(iq)) then ! use tracer names stored in dynamics
+        if (txt.ne.nametrac(iq)) then ! use tracer names stored in dynamics
           ! did not find old tracer name
           exit ! might as well stop here
@@ -629,5 +634,5 @@
         endif
       enddo
-      if (count.eq.nqmx) then
+      if (count.eq.nq) then
         write(*,*) "physdem1:tracers seem to follow old naming ",
      &             "convention (qsurf01,qsurf02,...)"
@@ -638,11 +643,11 @@
         !oldtracernames=.true.
         ! Moreover, if computing water cycle with ice, move surface ice
-        ! back to qsurf(nqmx)
+        ! back to qsurf(nq)
         !IF (iceparty) THEN
-        !  write(*,*)'physdem1: moving surface water ice to index ',nqmx
-        !  qsurf(1:ngridmx,nqmx)=qsurf(1:ngridmx,nqmx-1)
-        !  qsurf(1:ngridmx,nqmx-1)=0
+        !  write(*,*)'physdem1: moving surface water ice to index ',nq
+        !  qsurf(1:ngrid,nq)=qsurf(1:ngrid,nq-1)
+        !  qsurf(1:ngrid,nq-1)=0
         !ENDIF
-      endif ! of if (count.eq.nqmx)
+      endif ! of if (count.eq.nq)
 
       IF(nq.GE.1) THEN
@@ -650,8 +655,8 @@
         if (.not.oldtracernames) then
          do iq=1,nq
-           if (tnom(iq).eq."h2o_vap") then
+           if (nametrac(iq).eq."h2o_vap") then
              i_h2o_vap=iq
            endif
-           if (tnom(iq).eq."h2o_ice") then
+           if (nametrac(iq).eq."h2o_ice") then
              i_h2o_ice=iq
            endif
@@ -671,5 +676,5 @@
              write(txt,'(a5,i2.2)')'qsurf',iq
            ELSE
-             txt=tnom(iq)
+             txt=nametrac(iq)
 
 
